#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_START 5 // Назначение пина, к которому подключена тактовая кнопка запуска
#define PHOTO_RIGHT A0 // Назначение пина, к которому подключен правый фоторезистор
#define PHOTO_LEFT A1 // Назначение пина, к которому подключен левый фоторезистор

bool button_state; // Объявление переменной button_state
bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false

int difference=100; // Объявление переменной difference и присвоение ей значения 100
int speeds=100; // Б.1 - Объявление переменной speeds и присвоение ей значения 100
int counter; // Объявление переменной counter
int brightness_right=0; // Б.1 - Объявление переменной brightness_right и присвоение ей значения 0
int brightness_left=0; // Б.1 - Объявление переменной brightness_left и присвоение ей значения 0
int brightness_right_was=0; // Б.1 - Объявление переменной brightness_right_was и присвоение ей значения 0
int brightness_left_was=0; // Б.1 - Объявление переменной brightness_left_was и присвоение ей значения 0

void button_read(); // Объявление подпрограммы обработки состояния кнопки запуска/останова
void zapusk(); // Объявление подпрограммы подготовки робота к работе

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

void setup() {
Board::vertor_STM(); // Объявление типа используемого контроллера - vertor_STM

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
 
pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод

}

void loop() {
  button_read(); // Б.2 - Вызов функции обработки состояния кнопки запуска
  if(robot_state==true) // Б.3 - Если значение переменной robot_state равно true, то выполнить действие в скобках
  {
  zapusk(); // Б.4 - Вызов функции подготовки робота к запуску
  while(robot_state==true) // Б.5 - Цикл While(). Выполнять до тех пор, пока значение переменной robot_state равно true
  {    
    brightness_right=analogRead(PHOTO_RIGHT); // Б.6 - Сохранение значения на пине PHOTO_RIGHT в переменную brightness_right
    brightness_left=analogRead(PHOTO_LEFT); // Б.6 - Сохранение значения на пине PHOTO_LEFT в переменную brightness_left    
    if(brightness_right<5) // Б.7 - Если значение переменной brightness_right меньше 5, то выполнить действие в скобках
    {      
      if(brightness_left<5) // Б.8 - Если значение переменной brightness_left меньше 5, то выполнить действие в скобках
      {       
       motor_right->forward(speeds); // Б.9 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
       motor_left->backward(speeds); // Б.9 - Команда на запуск мотора motor_left со скоростью speeds % в обраном направлении
      }      
    }
    else if(abs(brightness_left-brightness_right)<difference) // Б.10 - Если абсолютное значение разности значений переменных brightness_left и brightness_right меньше значения переменной difference, то выполнить инструкции в скобках
    {
      motor_right->forward(speeds); // Б.11 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
      motor_left->forward(speeds); // Б.11 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении      
    }
    else if(brightness_right>brightness_left) // Б.12 - Если значение переменной brightness_right больше значения переменной brightness_left, то выполнить инструкции в скобках
    {   
      if(brightness_left<brightness_left_was) // Б.13 - Если значение переменной brightness_left_was больше значения переменной brightness_left, то выполнить инструкции в скобках
      {
       if(brightness_right>brightness_right_was) // Б.14 - Если значение переменной brightness_right больше значения переменной brightness_right_was, то выполнить инструкции в скобках
      {         
       motor_right->backward(speeds); // Б.15 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении 
       motor_left->forward(speeds); // Б.15 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении         
      }   
      }             
    }    
    else if(brightness_left>brightness_right) // Б.16 - Если значение переменной brightness_left больше значения переменной brightness_right, то выполнить инструкции в скобках
    {  
      if(brightness_right<brightness_right_was) // Б.17 - Если значение переменной brightness_right_was больше значения переменной brightness_right, то выполнить инструкции в скобках
      {         
      if(brightness_left>brightness_left_was) // Б.18 - Если значение переменной brightness_left больше значения переменной brightness_left_was, то выполнить инструкции в скобках
      {
       motor_right->forward(speeds); // Б.19 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении 
       motor_left->backward(speeds); // Б.19 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении        
      } 
      }                  
    }    
     brightness_right_was=brightness_right; // Б.20 - Присвоение переменной brightness_right_was значение переменной brightness_right
     brightness_left_was=brightness_left; // Б.20 - Присвоение переменной brightness_left_was значение переменной brightness_left          
     delay(100); // Б.21 - Ожидание 0,1 секунду      
     button_state=digitalRead(BUTTON_START); // Б.22 - Сохранение состояния на пине BUTTON_START в переменную button_state
     if(button_state==0) // Б.23 - Если значение переменной button_state равно 0, то 
     {
      robot_state=false; // Б.24 - Присвоение переменной robot_state значение false      
      motor_right->stop(false); // Б.25 - Команда на остановку вращения мотора motor_right
      motor_left->stop(false); // Б.25 - Команда на остановку вращения мотора motor_left           
      delay(1500); // Б.26 - Ожидание 1,5 секунды
     }     
  }     
  }  
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.2.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.2.3 - Ожидание 0,01 с
  button_state=digitalRead(BUTTON_START); // Б.2.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.2.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.2.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.2.7 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.2.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.4.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.4.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.4.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.4.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.4.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.4.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.4.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.4.6 - Ожидание 0,5 секунд
   counter=counter+1; // Б.4.7 - Увеличение значения переменной counter на 1
  }          
}
